summaryrefslogtreecommitdiff
path: root/.config/zsh/plugins/zsh-syntax-highlighting/tests
diff options
context:
space:
mode:
Diffstat (limited to '.config/zsh/plugins/zsh-syntax-highlighting/tests')
-rw-r--r--.config/zsh/plugins/zsh-syntax-highlighting/tests/README.md124
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/edit-failed-tests40
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/generate.zsh117
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-colorizer.zsh71
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-filter47
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/test-highlighting.zsh291
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/test-perfs.zsh103
-rwxr-xr-x.config/zsh/plugins/zsh-syntax-highlighting/tests/test-zprof.zsh78
8 files changed, 871 insertions, 0 deletions
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/README.md b/.config/zsh/plugins/zsh-syntax-highlighting/tests/README.md
new file mode 100644
index 0000000..cb3d943
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/README.md
@@ -0,0 +1,124 @@
+zsh-syntax-highlighting / tests
+===============================
+
+Utility scripts for testing zsh-syntax-highlighting highlighters.
+
+The tests harness expects the highlighter directory to contain a `test-data`
+directory with test data files.
+See the [main highlighter](../highlighters/main/test-data) for examples.
+
+Tests should set the following variables:
+
+1.
+Each test should define the string `$BUFFER` that is to be highlighted and the
+array parameter `$expected_region_highlight`.
+The value of that parameter is a list of strings of the form `"$i $j $style"`.
+or `"$i $j $style $todo"`.
+Each string specifies the highlighting that `$BUFFER[$i,$j]` should have;
+that is, `$i` and `$j` specify a range, 1-indexed, inclusive of both endpoints.
+`$style` is a key of `$ZSH_HIGHLIGHT_STYLES`.
+If `$todo` exists, the test point is marked as TODO (the failure of that test
+point will not fail the test), and `$todo` is used as the explanation.
+
+2.
+If a test sets `$skip_test` to a non-empty string, the test will be skipped
+with the provided string as the reason.
+
+3.
+If a test sets `$fail_test` to a non-empty string, the test will be skipped
+with the provided string as the reason.
+
+4.
+If a test sets `unsorted=1` the order of highlights in `$expected_region_highlight`
+need not match the order in `$region_highlight`.
+
+5.
+Normally, tests fail if `$expected_region_highlight` and `$region_highlight`
+have different numbers of elements. To mark this check as expected to fail,
+tests may set `$expected_mismatch` to an explanation string (like `$todo`);
+this is useful when the only difference between actual and expected is that actual
+has some additional, superfluous elements. This check is skipped if the
+`$todo` component is present in any regular test point.
+
+**Note**: `$region_highlight` uses the same `"$i $j $style"` syntax but
+interprets the indexes differently.
+
+**Note**: Tests are run with `setopt NOUNSET WARN_CREATE_GLOBAL`, so any
+variables the test creates must be declared local.
+
+**Isolation**: Each test is run in a separate subshell, so any variables,
+aliases, functions, etc., it defines will be visible to the tested code (that
+computes `$region_highlight`), but will not affect subsequent tests. The
+current working directory of tests is set to a newly-created empty directory,
+which is automatically cleaned up after the test exits. For example:
+
+```zsh
+setopt PATH_DIRS
+mkdir -p foo/bar
+touch foo/bar/testing-issue-228
+chmod +x foo/bar/testing-issue-228
+path+=( "$PWD"/foo )
+
+BUFFER='bar/testing-issue-228'
+
+expected_region_highlight=(
+ "1 21 command" # bar/testing-issue-228
+)
+```
+
+
+Writing new tests
+-----------------
+
+An experimental tool is available to generate test files:
+
+```zsh
+zsh -f tests/generate.zsh 'ls -x' acme newfile
+```
+
+This generates a `highlighters/acme/test-data/newfile.zsh` test file based on
+the current highlighting of the given `$BUFFER` (in this case, `ls -x`).
+
+_This tool is experimental._ Its interface may change. In particular it may
+grow ways to set `$PREBUFFER` to inject free-form code into the generated file.
+
+
+Highlighting test
+-----------------
+
+[`test-highlighting.zsh`](tests/test-highlighting.zsh) tests the correctness of
+the highlighting. Usage:
+
+```zsh
+zsh test-highlighting.zsh <HIGHLIGHTER NAME>
+```
+
+All tests may be run with
+
+```zsh
+make test
+```
+
+which will run all highlighting tests and report results in [TAP format][TAP].
+By default, the results of all tests will be printed; to show only "interesting"
+results (tests that failed but were expected to succeed, or vice-versa), run
+`make quiet-test` (or `make test QUIET=y`).
+
+[TAP]: http://testanything.org/
+
+
+Performance test
+----------------
+
+[`test-perfs.zsh`](tests/test-perfs.zsh) measures the time spent doing the
+highlighting. Usage:
+
+```zsh
+zsh test-perfs.zsh <HIGHLIGHTER NAME>
+```
+
+All tests may be run with
+
+```zsh
+make perf
+```
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/edit-failed-tests b/.config/zsh/plugins/zsh-syntax-highlighting/tests/edit-failed-tests
new file mode 100755
index 0000000..e3a7668
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/edit-failed-tests
@@ -0,0 +1,40 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2020 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+type perl sponge >/dev/null || { print -ru2 -- "$0: This script requires perl(1) and sponge(1) [from moreutils]"; exit 1; }
+
+local editor=( "${(@Q)${(z)${VISUAL:-${EDITOR:-vi}}}}" )
+() {
+ > "$2" perl -nE '$highlighter = $1 if /^Running test (\S*)/; say "highlighters/${highlighter}/test-data/$1.zsh" if /^## (\S*)/' "$1"
+ >>"$2" echo ""
+ >>"$2" cat <"$1"
+ "${editor[@]}" -- "$2"
+} =(${MAKE:-make} quiet-test) =(:)
+# TODO: tee(1) the quiet-test output to /dev/tty as it's happening, with colors.
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/generate.zsh b/.config/zsh/plugins/zsh-syntax-highlighting/tests/generate.zsh
new file mode 100755
index 0000000..5696020
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/generate.zsh
@@ -0,0 +1,117 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2016 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+emulate -LR zsh
+setopt localoptions extendedglob
+
+# Required for add-zle-hook-widget.
+zmodload zsh/zle
+
+# Argument parsing.
+if (( $# * $# - 7 * $# + 12 )) || [[ $1 == -* ]]; then
+ print -r -- >&2 "$0: usage: $0 BUFFER HIGHLIGHTER BASENAME [PREAMBLE]"
+ print -r -- >&2 ""
+ print -r -- >&2 "Generate highlighters/HIGHLIGHTER/test-data/BASENAME.zsh based on the"
+ print -r -- >&2 "current highlighting of BUFFER, using the setup code PREAMBLE."
+ exit 1
+fi
+buffer=$1
+ZSH_HIGHLIGHT_HIGHLIGHTERS=( $2 )
+fname=${0:A:h:h}/highlighters/$2/test-data/${3%.zsh}.zsh
+preamble=${4:-""}
+
+# Load the main script.
+. ${0:A:h:h}/zsh-syntax-highlighting.zsh
+
+# Overwrite _zsh_highlight_add_highlight so we get the key itself instead of the style
+_zsh_highlight_add_highlight()
+{
+ region_highlight+=("$1 $2 $3")
+}
+
+
+# Copyright block
+year="`LC_ALL=C date +%Y`"
+if ! { read -q "?Set copyright year to $year? " } always { echo "" }; then
+ year="YYYY"
+fi
+<$0 sed -n -e '1,/^$/p' | sed -e "s/2[0-9][0-9][0-9]/${year}/" > $fname
+# Assumes stdout is line-buffered
+git add -- $fname
+exec > >(tee -a $fname)
+
+# Preamble
+if [[ -n $preamble ]]; then
+ print -rl -- "$preamble" ""
+fi
+
+# Buffer
+print -n 'BUFFER='
+if [[ $buffer != (#s)[$'\t -~']#(#e) ]]; then
+ print -r -- ${(qqqq)buffer}
+else
+ print -r -- ${(qq)buffer}
+fi
+echo ""
+
+# Expectations
+print 'expected_region_highlight=('
+() {
+ local i
+ local PREBUFFER
+ local BUFFER
+
+ PREBUFFER=""
+ BUFFER="$buffer"
+ region_highlight=()
+ eval $(
+ exec 3>&1 >/dev/null
+ typeset -r __tests_tmpdir="$(mktemp -d)"
+ {
+ # Use a subshell to ensure $__tests_tmpdir, which is to be rm -rf'd, won't be modified.
+ (cd -- "$__tests_tmpdir" && eval $preamble && _zsh_highlight && typeset -p region_highlight >&3)
+ : # workaround zsh bug workers/45305 with respect to the $(…) subshell we're in
+ } always {
+ rm -rf -- ${__tests_tmpdir}
+ }
+ )
+
+ for ((i=1; i<=${#region_highlight}; i++)); do
+ local -a highlight_zone; highlight_zone=( ${(z)region_highlight[$i]} )
+ integer start=$highlight_zone[1] end=$highlight_zone[2]
+ if (( start < end )) # region_highlight ranges are half-open
+ then
+ (( --end )) # convert to closed range, like expected_region_highlight
+ (( ++start, ++end )) # region_highlight is 0-indexed; expected_region_highlight is 1-indexed
+ fi
+ printf " %s # %s\n" ${(qq):-"$start $end $highlight_zone[3]"} ${${(qqqq)BUFFER[start,end]}[3,-2]}
+ done
+}
+print ')'
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-colorizer.zsh b/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-colorizer.zsh
new file mode 100755
index 0000000..f3dc84e
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-colorizer.zsh
@@ -0,0 +1,71 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2015, 2017 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+# This is a stdin-to-stdout filter that takes TAP output (such as 'make test')
+# on stdin and passes it, colorized, to stdout.
+
+emulate -LR zsh
+
+if [[ ! -t 1 ]] ; then
+ exec cat
+fi
+
+while read -r line;
+do
+ case $line in
+ # comment (filename header) or plan
+ (#* | <->..<->)
+ print -nP %F{blue}
+ ;;
+ # SKIP
+ (*# SKIP*)
+ print -nP %F{yellow}
+ ;;
+ # XPASS
+ (ok*# TODO*)
+ print -nP %F{red}
+ ;;
+ # XFAIL
+ (not ok*# TODO*)
+ print -nP %F{yellow}
+ ;;
+ # FAIL
+ (not ok*)
+ print -nP %F{red}
+ ;;
+ # PASS
+ (ok*)
+ print -nP %F{green}
+ ;;
+ esac
+ print -nr - "$line"
+ print -nP %f
+ echo "" # newline
+done
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-filter b/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-filter
new file mode 100755
index 0000000..f9aa604
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/tap-filter
@@ -0,0 +1,47 @@
+#!/usr/bin/env perl
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2015 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# vim: ft=perl sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+# This is a stdin-to-stdout filter that takes TAP output (such as 'make test')
+# on stdin and deletes lines pertaining to expected results.
+#
+# More specifically, if any of the test points in a test file either failed but
+# was expected to pass, or passed but was expected to fail, then emit that test
+# file's output; else, elide that test file's output.
+
+use v5.10.0;
+use warnings;
+use strict;
+
+undef $/; # slurp mode
+print for
+ grep { /^ok.*# TODO/m or /^not ok(?!.*# TODO)/m or /^Bail out!/m }
+ # Split on plan lines and remove them from the output. (To keep them,
+ # use the lookahead syntax, «(?=…)», to make the match zero-length.)
+ split /^\d+\.\.\d+$/m,
+ <STDIN>;
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-highlighting.zsh b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-highlighting.zsh
new file mode 100755
index 0000000..8b564a8
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-highlighting.zsh
@@ -0,0 +1,291 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2010-2017 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+
+setopt NO_UNSET WARN_CREATE_GLOBAL
+
+# Required for add-zle-hook-widget.
+zmodload zsh/zle
+
+local -r root=${0:h:h}
+local -a anon_argv; anon_argv=("$@")
+
+(){
+set -- "${(@)anon_argv}"
+# Check an highlighter was given as argument.
+[[ -n "$1" ]] || {
+ echo >&2 "Bail out! You must provide the name of a valid highlighter as argument."
+ exit 2
+}
+
+# Check the highlighter is valid.
+[[ -f $root/highlighters/$1/$1-highlighter.zsh ]] || {
+ echo >&2 "Bail out! Could not find highlighter ${(qq)1}."
+ exit 2
+}
+
+# Check the highlighter has test data.
+[[ -d $root/highlighters/$1/test-data ]] || {
+ echo >&2 "Bail out! Highlighter ${(qq)1} has no test data."
+ exit 2
+}
+
+# Set up results_filter
+local results_filter
+if [[ ${QUIET-} == y ]]; then
+ if type -w perl >/dev/null; then
+ results_filter=$root/tests/tap-filter
+ else
+ echo >&2 "Bail out! quiet mode not supported: perl not found"; exit 2
+ fi
+else
+ results_filter=cat
+fi
+[[ -n $results_filter ]] || { echo >&2 "Bail out! BUG setting \$results_filter"; exit 2 }
+
+# Load the main script.
+# While here, test that it doesn't eat aliases.
+print > >($results_filter | $root/tests/tap-colorizer.zsh) -r -- "# global (driver) tests"
+print > >($results_filter | $root/tests/tap-colorizer.zsh) -r -- "1..1"
+alias -- +plus=plus
+alias -- _other=other
+local original_alias_dash_L_output="$(alias -L)"
+. $root/zsh-syntax-highlighting.zsh
+if [[ $original_alias_dash_L_output == $(alias -L) ]]; then
+ print -r -- "ok 1 # 'alias -- +foo=bar' is preserved"
+else
+ print -r -- "not ok 1 # 'alias -- +foo=bar' is preserved"
+ exit 1
+fi > >($results_filter | $root/tests/tap-colorizer.zsh)
+
+# Overwrite _zsh_highlight_add_highlight so we get the key itself instead of the style
+_zsh_highlight_add_highlight()
+{
+ region_highlight+=("$1 $2 $3")
+}
+
+# Activate the highlighter.
+ZSH_HIGHLIGHT_HIGHLIGHTERS=($1)
+
+# In zsh<5.3, 'typeset -p arrayvar' emits two lines, so we use this wrapper instead.
+typeset_p() {
+ for 1 ; do
+ if [[ ${(tP)1} == *array* ]]; then
+ print -r -- "$1=( ${(@qqqqP)1} )"
+ else
+ print -r -- "$1=${(qqqqP)1}"
+ fi
+ done
+}
+
+# Escape # as ♯ and newline as ↵ they are illegal in the 'description' part of TAP output
+# The string to escape is «"$@"»; the result is returned in $REPLY.
+tap_escape() {
+ local s="${(j. .)@}"
+ REPLY="${${s//'#'/♯}//$'\n'/↵}"
+}
+
+# Runs a highlighting test
+# $1: data file
+run_test_internal() {
+
+ local tests_tempdir="$1"; shift
+ local srcdir="$PWD"
+ builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! On ${(qq)1}: cd failed: $?"; return 1 }
+
+ # Load the data and prepare checking it.
+ local BUFFER CURSOR MARK PENDING PREBUFFER REGION_ACTIVE WIDGET REPLY skip_test fail_test unsorted=0
+ local expected_mismatch
+ local skip_mismatch
+ local -a expected_region_highlight region_highlight
+
+ local ARG="$1"
+ local RETURN=""
+ () {
+ setopt localoptions
+
+ # WARNING: The remainder of this anonymous function will run with the test's options in effect
+ if { ! . "$srcdir"/"$ARG" } || (( $#fail_test )); then
+ print -r -- "1..1"
+ print -r -- "## ${ARG:t:r}"
+ tap_escape $fail_test; fail_test=$REPLY
+ print -r -- "not ok 1 - failed setup: $fail_test"
+ return ${RETURN:=0}
+ fi
+
+ (( $#skip_test )) && {
+ print -r -- "1..0 # SKIP $skip_test"
+ print -r -- "## ${ARG:t:r}"
+ return ${RETURN:=0}
+ }
+
+ # Check the data declares $PREBUFFER or $BUFFER.
+ [[ -z $PREBUFFER && -z $BUFFER ]] && { echo >&2 "Bail out! On ${(qq)ARG}: Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank"; return ${RETURN:=1}; }
+ [[ $PREBUFFER == (''|*$'\n') ]] || { echo >&2 "Bail out! On ${(qq)ARG}: PREBUFFER=${(qqqq)PREBUFFER} doesn't end with a newline"; return ${RETURN:=1}; }
+
+ # Set sane defaults for ZLE variables
+ : ${CURSOR=$#BUFFER} ${PENDING=0} ${WIDGET=z-sy-h-test-harness-test-widget}
+
+ # Process the data.
+ _zsh_highlight
+ }; [[ -z $RETURN ]] || return $RETURN
+ unset ARG
+
+ integer print_expected_and_actual=0
+
+ if (( unsorted )); then
+ region_highlight=("${(@n)region_highlight}")
+ expected_region_highlight=("${(@n)expected_region_highlight}")
+ fi
+
+ # Print the plan line, and some comments for human readers
+ echo "1..$(( $#expected_region_highlight + 1))"
+ echo "## ${1:t:r}" # note: tests/edit-failed-tests looks for the "##" emitted by this line
+ [[ -n $PREBUFFER ]] && printf '# %s\n' "$(typeset_p PREBUFFER)"
+ [[ -n $BUFFER ]] && printf '# %s\n' "$(typeset_p BUFFER)"
+
+ local i
+ for ((i=1; i<=$#expected_region_highlight; i++)); do
+ local -a expected_highlight_zone; expected_highlight_zone=( ${(z)expected_region_highlight[i]} )
+ integer exp_start=$expected_highlight_zone[1] exp_end=$expected_highlight_zone[2]
+ local todo=
+ if (( $+expected_highlight_zone[4] )); then
+ todo="# TODO $expected_highlight_zone[4]"
+ skip_mismatch="cardinality check disabled whilst regular test points are expected to fail"
+ fi
+ if ! (( $+region_highlight[i] )); then
+ print -r -- "not ok $i - unmatched expectation ($exp_start $exp_end $expected_highlight_zone[3])" \
+ "${skip_mismatch:+"# TODO ${(qqq)skip_mismatch}"}"
+ if [[ -z $skip_mismatch ]]; then (( ++print_expected_and_actual )); fi
+ continue
+ fi
+ local -a highlight_zone; highlight_zone=( ${(z)region_highlight[i]} )
+ integer start=$(( highlight_zone[1] + 1 )) end=$highlight_zone[2]
+ local desc="[$start,$end] «${BUFFER[$start,$end]}»"
+ tap_escape $desc; desc=$REPLY
+ if
+ [[ $start != $exp_start ]] ||
+ [[ $end != $exp_end ]] ||
+ [[ ${highlight_zone[3]%,} != ${expected_highlight_zone[3]} ]] # remove the comma that's before the memo field
+ then
+ print -r -- "not ok $i - $desc - expected ($exp_start $exp_end ${(qqq)expected_highlight_zone[3]}), observed ($start $end ${(qqq)highlight_zone[3]}). $todo"
+ if [[ -z $todo ]]; then (( ++print_expected_and_actual )); fi
+ else
+ print -r -- "ok $i - $desc${todo:+ - }$todo"
+ fi
+ unset expected_highlight_zone
+ unset exp_start exp_end
+ unset todo
+ unset highlight_zone
+ unset start end
+ unset desc
+ done
+
+ # If both $skip_mismatch and $expected_mismatch are set, that means the test
+ # has some XFail test points, _and_ explicitly sets $expected_mismatch as
+ # well. Explicit settings should have priority, so we ignore $skip_mismatch
+ # if $expected_mismatch is set.
+ if [[ -n $skip_mismatch && -z $expected_mismatch ]]; then
+ tap_escape $skip_mismatch; skip_mismatch=$REPLY
+ print "ok $i - cardinality check" "# SKIP $skip_mismatch"
+ else
+ local todo
+ if [[ -n $expected_mismatch ]]; then
+ tap_escape $expected_mismatch; expected_mismatch=$REPLY
+ todo="# TODO $expected_mismatch"
+ fi
+ if (( $#expected_region_highlight == $#region_highlight )); then
+ print -r -- "ok $i - cardinality check${todo:+ - }$todo"
+ else
+ local details
+ details+="have $#expected_region_highlight expectations and $#region_highlight region_highlight entries: "
+ details+="«$(typeset_p expected_region_highlight)» «$(typeset_p region_highlight)»"
+ tap_escape $details; details=$REPLY
+ print -r -- "not ok $i - cardinality check - $details${todo:+ - }$todo"
+ if [[ -z $todo ]]; then (( ++print_expected_and_actual )); fi
+ fi
+ fi
+ if (( print_expected_and_actual )); then
+ () {
+ local -a left_column right_column
+ left_column=( "expected_region_highlight" "${(qq)expected_region_highlight[@]}" )
+ right_column=( "region_highlight" "${(qq)region_highlight[@]}" )
+ integer difference=$(( $#right_column - $#left_column ))
+ repeat $difference do left_column+=(.); done
+ paste \
+ =(print -rC1 -- $left_column) \
+ =(print -rC1 -- $right_column) \
+ | if type column >/dev/null; then column -t -s $'\t'; else cat; fi \
+ | sed 's/^/# /'
+ }
+ fi
+}
+
+# Run a single test file. The exit status is 1 if the test harness had
+# an error and 0 otherwise. The exit status does not depend on whether
+# test points succeeded or failed.
+run_test() {
+ # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
+ local __tests_tempdir
+ __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
+ echo >&2 "Bail out! mktemp failed"; return 1
+ }
+ typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
+
+ {
+ # Use a subshell to isolate tests from each other.
+ # (So tests can alter global shell state using 'cd', 'hash', etc)
+ {
+ # These braces are so multios don't come into play.
+ { (run_test_internal "$__tests_tempdir" "$@") 3>&1 >&2 2>&3 } | grep \^
+ local ret=$pipestatus[1] stderr=$pipestatus[2]
+ if (( ! stderr )); then
+ # stdout will become stderr
+ echo "Bail out! On ${(qq)1}: output on stderr"; return 1
+ else
+ return $ret
+ fi
+ } 3>&1 >&2 2>&3
+ } always {
+ rm -rf -- "$__tests_tempdir"
+ }
+}
+
+# Process each test data file in test data directory.
+integer something_failed=0
+ZSH_HIGHLIGHT_STYLES=()
+local data_file
+for data_file in $root/highlighters/$1/test-data/*.zsh; do
+ run_test "$data_file" | tee >($results_filter | $root/tests/tap-colorizer.zsh) | grep -v '^not ok.*# TODO' | grep -Eq '^not ok|^ok.*# TODO' && (( something_failed=1 ))
+ (( $pipestatus[1] )) && exit 2
+done
+
+exit $something_failed
+}
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-perfs.zsh b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-perfs.zsh
new file mode 100755
index 0000000..aa139aa
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-perfs.zsh
@@ -0,0 +1,103 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+
+# Required for add-zle-hook-widget.
+zmodload zsh/zle
+
+# Check an highlighter was given as argument.
+[[ -n "$1" ]] || {
+ echo >&2 "Bail out! You must provide the name of a valid highlighter as argument."
+ exit 2
+}
+
+# Check the highlighter is valid.
+[[ -f ${0:h:h}/highlighters/$1/$1-highlighter.zsh ]] || {
+ echo >&2 "Bail out! Could not find highlighter ${(qq)1}."
+ exit 2
+}
+
+# Check the highlighter has test data.
+[[ -d ${0:h:h}/highlighters/$1/test-data ]] || {
+ echo >&2 "Bail out! Highlighter ${(qq)1} has no test data."
+ exit 2
+}
+
+# Load the main script.
+typeset -a region_highlight
+. ${0:h:h}/zsh-syntax-highlighting.zsh
+
+# Activate the highlighter.
+ZSH_HIGHLIGHT_HIGHLIGHTERS=($1)
+
+# Runs a highlighting test
+# $1: data file
+run_test_internal() {
+ local -a highlight_zone
+
+ local tests_tempdir="$1"; shift
+ local srcdir="$PWD"
+ builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
+
+ # Load the data and prepare checking it.
+ PREBUFFER= BUFFER= ;
+ . "$srcdir"/"$1"
+
+ # Check the data declares $PREBUFFER or $BUFFER.
+ [[ -z $PREBUFFER && -z $BUFFER ]] && { echo >&2 "Bail out! Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank"; return 1; }
+
+ # Set $? for _zsh_highlight
+ true && _zsh_highlight
+}
+
+run_test() {
+ # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
+ local __tests_tempdir
+ __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
+ echo >&2 "Bail out! mktemp failed"; return 1
+ }
+ typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
+
+ {
+ (run_test_internal "$__tests_tempdir" "$@")
+ } always {
+ rm -rf -- "$__tests_tempdir"
+ }
+}
+
+# Process each test data file in test data directory.
+local data_file
+TIMEFMT="%*Es"
+{ time (for data_file in ${0:h:h}/highlighters/$1/test-data/*.zsh; do
+ run_test "$data_file"
+ (( $pipestatus[1] )) && exit 2
+done) } 2>&1 || exit $?
+
+exit 0
diff --git a/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-zprof.zsh b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-zprof.zsh
new file mode 100755
index 0000000..ada1618
--- /dev/null
+++ b/.config/zsh/plugins/zsh-syntax-highlighting/tests/test-zprof.zsh
@@ -0,0 +1,78 @@
+#!/usr/bin/env zsh
+# -------------------------------------------------------------------------------------------------
+# Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification, are permitted
+# provided that the following conditions are met:
+#
+# * Redistributions of source code must retain the above copyright notice, this list of conditions
+# and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright notice, this list of
+# conditions and the following disclaimer in the documentation and/or other materials provided
+# with the distribution.
+# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
+# may be used to endorse or promote products derived from this software without specific prior
+# written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
+# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# -------------------------------------------------------------------------------------------------
+# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
+# vim: ft=zsh sw=2 ts=2 et
+# -------------------------------------------------------------------------------------------------
+
+# Load the main script.
+typeset -a region_highlight
+. ${0:h:h}/zsh-syntax-highlighting.zsh
+
+# Activate the highlighter.
+ZSH_HIGHLIGHT_HIGHLIGHTERS=(main)
+
+source_file=0.7.1:highlighters/$1/$1-highlighter.zsh
+
+# Runs a highlighting test
+# $1: data file
+run_test_internal() {
+ setopt interactivecomments
+
+ local -a highlight_zone
+
+ local tests_tempdir="$1"; shift
+ local srcdir="$PWD"
+ builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
+
+ # Load the data and prepare checking it.
+ PREBUFFER=
+ BUFFER=$(cd -- "$srcdir" && git cat-file blob $source_file)
+ expected_region_highlight=()
+
+ zmodload zsh/zprof
+ zprof -c
+ # Set $? for _zsh_highlight
+ true && _zsh_highlight
+ zprof
+}
+
+run_test() {
+ # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
+ local __tests_tempdir
+ __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
+ echo >&2 "Bail out! mktemp failed"; return 1
+ }
+ typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
+
+ {
+ (run_test_internal "$__tests_tempdir" "$@")
+ } always {
+ rm -rf -- "$__tests_tempdir"
+ }
+}
+
+run_test